"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  buildSchema: () => buildSchema
});
module.exports = __toCommonJS(src_exports);
var import_drizzle_orm = require("drizzle-orm");
var import_mysql_core = require("drizzle-orm/mysql-core");
var import_pg_core = require("drizzle-orm/pg-core");
var import_sqlite_core = require("drizzle-orm/sqlite-core");
var import_graphql = require("graphql");
var import_builders = require("./util/builders");
__reExport(src_exports, require("./types"), module.exports);
const buildSchema = (db) => {
  const schema = db._.fullSchema;
  let generatorOutput;
  if ((0, import_drizzle_orm.is)(db, import_mysql_core.MySqlDatabase)) {
    generatorOutput = (0, import_builders.generateMySQL)(db, schema);
  } else if ((0, import_drizzle_orm.is)(db, import_pg_core.PgDatabase)) {
    generatorOutput = (0, import_builders.generatePG)(db, schema);
  } else if ((0, import_drizzle_orm.is)(db, import_sqlite_core.BaseSQLiteDatabase)) {
    generatorOutput = (0, import_builders.generateSQLite)(db, schema);
  } else
    throw new Error("Unknown database instance type");
  const { queries, mutations, inputs, types } = generatorOutput;
  const query = new import_graphql.GraphQLObjectType({
    name: "Query",
    fields: queries
  });
  const mutation = new import_graphql.GraphQLObjectType({
    name: "Mutation",
    fields: mutations
  });
  const outputSchema = new import_graphql.GraphQLSchema({
    query,
    mutation,
    types: [...Object.values(inputs), ...Object.values(types)]
  });
  return { schema: outputSchema, entities: generatorOutput };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  buildSchema,
  ...require("./types")
});
//# sourceMappingURL=index.cjs.map