import { SQL } from 'drizzle-orm';
import { GraphQLInputObjectType } from 'graphql';
import type { Column, Relation, Table } from 'drizzle-orm';
import type { FieldNode, GraphQLResolveInfo } from 'graphql';
import type { FilterColumnOperators, Filters, GeneratedTableTypes, OrderByArgs, ProcessedTableSelectArgs } from './types';
export declare const extractSelectedColumns: (info: GraphQLResolveInfo, queryName: string) => Record<string, true>;
export declare const extractSelectedColumnsFromNode: (info: FieldNode, table: Table) => Record<string, true>;
export declare const extractSelectedColumnsSQLFormat: <TTable extends Table<import("drizzle-orm").TableConfig<Column<any, object, object>>>>(info: GraphQLResolveInfo, queryName: string, table: TTable) => Record<string, Column>;
export declare const innerOrder: GraphQLInputObjectType;
export declare const generateTableTypes: <TRelations extends Record<string, Relation<string>> | undefined, WithReturning extends boolean>(tableName: string, table: Table, withReturning: WithReturning, relations?: TRelations) => GeneratedTableTypes<WithReturning>;
export declare const extractOrderBy: <TTable extends Table<import("drizzle-orm").TableConfig<Column<any, object, object>>>, TArgs extends OrderByArgs<any> = OrderByArgs<TTable>>(table: TTable, orderArgs: TArgs) => SQL[];
export declare const extractFiltersColumn: <TColumn extends Column<import("drizzle-orm").ColumnBaseConfig<import("drizzle-orm").ColumnDataType, string>, object, object>>(column: TColumn, columnName: string, operators: FilterColumnOperators<TColumn>) => SQL | undefined;
export declare const extractFilters: <TTable extends Table<import("drizzle-orm").TableConfig<Column<any, object, object>>>>(table: TTable, tableName: string, filters: Filters<TTable>) => SQL | undefined;
export declare const extractRelationsParams: (relations: Record<string, Relation>, tableSelection: FieldNode, typeName: string, info: GraphQLResolveInfo) => Record<string, Partial<ProcessedTableSelectArgs>> | undefined;
