"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var type_converter_exports = {};
__export(type_converter_exports, {
  drizzleColumnToGraphQLType: () => drizzleColumnToGraphQLType
});
module.exports = __toCommonJS(type_converter_exports);
var import_graphql = require("graphql");
var import_drizzle_orm = require("drizzle-orm");
var import_pg_core = require("drizzle-orm/pg-core");
var import_mysql_core = require("drizzle-orm/mysql-core");
var import_sqlite_core = require("drizzle-orm/sqlite-core");
__reExport(type_converter_exports, require("./types"), module.exports);
const columnToGraphQLCore = (column) => {
  switch (column.dataType) {
    case "boolean":
      return { type: import_graphql.GraphQLBoolean, description: "Boolean" };
    case "json":
      return { type: import_graphql.GraphQLString, description: "JSON" };
    case "date":
      return { type: import_graphql.GraphQLString, description: "Date" };
    case "string":
      return { type: import_graphql.GraphQLString, description: "String" };
    case "bigint":
      return { type: import_graphql.GraphQLString, description: "BigInt" };
    case "number":
      return (0, import_drizzle_orm.is)(column, import_pg_core.PgInteger) || (0, import_drizzle_orm.is)(column, import_pg_core.PgSerial) || (0, import_drizzle_orm.is)(column, import_mysql_core.MySqlInt) || (0, import_drizzle_orm.is)(column, import_mysql_core.MySqlSerial) || (0, import_drizzle_orm.is)(column, import_sqlite_core.SQLiteInteger) ? { type: import_graphql.GraphQLInt, description: "Integer" } : { type: import_graphql.GraphQLFloat, description: "Float" };
    case "buffer":
      return { type: new import_graphql.GraphQLList(new import_graphql.GraphQLNonNull(import_graphql.GraphQLInt)), description: "Buffer" };
    case "array": {
      const innerType = columnToGraphQLCore(column.baseColumn);
      return {
        type: new import_graphql.GraphQLList(new import_graphql.GraphQLNonNull(innerType.type)),
        description: `Array<${innerType.description}>`
      };
    }
    case "custom":
    default:
      throw new Error(`Type ${column.dataType} is not implemented!`);
  }
};
const drizzleColumnToGraphQLType = (column, forceNullable = false, defaultIsNullable = false) => {
  const typeDesc = columnToGraphQLCore(column);
  const noDesc = ["string", "boolean", "number"];
  if (noDesc.find((e) => e === column.dataType))
    delete typeDesc.description;
  if (forceNullable)
    return typeDesc;
  if (column.notNull && !(defaultIsNullable && (column.hasDefault || column.defaultFn)))
    return {
      type: new import_graphql.GraphQLNonNull(typeDesc.type),
      description: typeDesc.description
    };
  return typeDesc;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  drizzleColumnToGraphQLType,
  ...require("./types")
});
//# sourceMappingURL=index.cjs.map